// strctptr.cpp -- funkce s parametry typu ukazatel na strukturu
#include <iostream>
#include <cmath>
using namespace std;

// ablony struktur
struct polar
{
	double distance;	// vzdlenost od potku
	double angle;		// smr od potku
};
struct rect
{
	double x;			// horizontln vzdlenost od potku
	double y;			// vertikln vzdlenost od potku
};

// prototypy
void rect_to_polar(const rect * pxy, polar * pda);
void show_polar (const polar * pda);

int main()
{
	rect rplace;
	polar pplace;

	cout << "Zadejte hodnoty x a y: ";
	while (cin >> rplace.x >> rplace.y)
	{
		rect_to_polar(&rplace, &pplace); // pedn adresy
		show_polar(&pplace); // pedn adresy
		cout << "Dalsi dve cisla (q na ukonceni): ";
	}
	cout << "Hotovo!\n";
	return 0;
}

// konvertuje pravohl souadnice na polrn
void rect_to_polar(const rect * pxy, polar * pda)
{
	pda->distance =
		sqrt(pxy->x * pxy->x + pxy->y * pxy->y);
	pda->angle = atan2(pxy->y, pxy->x);
}

// zobrazen polrnch souadnic spolu s konverz hlu na stupn
void show_polar (const polar * pda)
{
	const double Rad_to_deg = 57.29577951;
	cout << "vzdalenost = " << pda->distance;
	cout << ", uhel = " << pda->angle * Rad_to_deg;
	cout << " stupnu\n";
}
