// twoswap.cpp -- specializace pekrv ablonu
#include <iostream>
using namespace std;
template <class Any>
void Swap(Any &a, Any &b);

struct job
{
	char name[40];
	double salary;
	int floor;
};

// explicitn specializace
template <> void Swap<job>(job &j1, job &j2);
void Show(job &j);

int main()
{
	cout.precision(2);
	cout.setf(ios::fixed, ios::floatfield);
	int i = 10, j = 20;
	cout << "i, j = " << i << ", " << j << ".\n";
	cout << "Pouziti prekladacem generovane funkce pro zamenu cisel typu int:\n";
	Swap(i, j);				// generuje void Swap(int &, int &)
	cout << "Nyni i, j = " << i << ", " << j << ".\n";

	job sue = {"Susan Yaffee", 63000.60, 7};
	job sidney = {"Sidney Taffee", 66060.72, 9};
	cout << "Pred zamenou obsahu struktur job:\n";
	Show(sue);
	Show(sidney);
	Swap(sue, sidney);		// pouv void Swap(job &, job &)
	cout << "Po zamene obsahu struktur job:\n";
	Show(sue);
	Show(sidney);

	return 0;
}

template <class Any>
void Swap(Any &a, Any &b)		// obecn verze
{
	Any temp;
	temp = a;
	a = b;
	b = temp;
}

// zamuje pouze pole salary a floor struktury job

template <> void Swap<job>(job &j1, job &j2)	// specializace
{
	double t1;
	int t2;
	t1 = j1.salary;
	j1.salary = j2.salary;
	j2.salary = t1;
	t2 = j1.floor;
	j1.floor = j2.floor;
	j2.floor = t2;
}

void Show(job &j)
{
	cout << j.name << ": " << j.salary
	     << " Kc na poschodi " << j.floor << "\n";
}