// vector.cpp -- metody tdy Vector
#include <iostream>
#include <cmath>
using namespace std;
#include "vector.h"
const double Rad_to_deg = 57.2957795130823;

// privtn metody
// vypot velikost podle sloek x a y
void Vector::set_mag()
{
	mag = sqrt(x * x + y * y);
}

void Vector::set_ang()
{
	if (x == 0.0 && y == 0.0)
		ang = 0.0;
	else
		ang = atan2(y, x);
}

// nastav poloku x podle polrnch souadnic
void Vector::set_x()
{
	x = mag * cos(ang);
}

// nastav poloku y podle polrnch souadnic
void Vector::set_y()
{
	y = mag * sin(ang);
}

// veejn metody
Vector::Vector() // implicitn konstruktor
{
	x = y = mag = ang = 0.0;
	mode = 'r';
}

// jestlie form je 'r', vytvo vektor z pravohlch souadnic
// (implicitn), jinak z polrnch souadnic, pokud form je 'p'
Vector::Vector(double n1, double n2, char form)
{
	mode = form;
	if (form == 'r')
	{
		x = n1;
		y = n2;
		set_mag();
		set_ang();
	}
	else if (form == 'p')
	{
		mag = n1;
		ang = n2 / Rad_to_deg;
		set_x();
		set_y();
	}
	else
	{
		cout << " Nespravny 3. parametr pro metodu Vector() - -";
		cout << "vektor nastaven na hodnotu 0\n";
		x = y = mag = ang = 0.0;
		mode = 'r';
	}
}

// jestlie form je 'r', nastav vektor z pravohlch souadnic
// (implicitn), jinak z polrnch souadnic, pokud form je 'p'
void Vector:: set(double n1, double n2, char form)
{
	mode = form;
	if (form == 'r')
	{
		x = n1;
		y = n2;
		set_mag();
		set_ang();
	}
	else if (form == 'p')
	{
		mag = n1;
		ang = n2 / Rad_to_deg;
		set_x();
		set_y();
	}
	else
	{
		cout << "Nespravny 3. parametr pro metodu Vector() --";
		cout << "vektor nastaven na hodnotu 0\n";
		x = y = mag = ang = 0.0;
		mode = 'r';
	}
}

Vector::~Vector() // destruktor
{
}

void Vector::polar_mode() // nastav reim polrnch souadnic
{
	mode = 'p';
}
void Vector::rect_mode() // nastav reim pravohlch souadnic
{
	mode = 'r';
}

// petovn opertor
// stn dvou vektor
Vector Vector::operator+(const Vector & b) const
{
	return Vector(x + b.x, y + b.y);
}

// odetn vektoru b od vektoru a
Vector Vector::operator-(const Vector & b) const
{
	return Vector(x - b.x, y - b.y);
}

// zmna znamnka vektoru
Vector Vector::operator-() const
{
	return Vector(-x, -y);
}

// nsoben vektoru slem n
Vector Vector::operator*(double n) const
{
	return Vector(n * x, n * y);;
}

// sptelen metody
// nsoben sla n vektorem a
Vector operator*(double n, const Vector & a)
{
	return a * n;
}

// jestlie mode je 'r', zobraz pravohl souadnice,
// jinak, pokud mode je 'p', zobraz souadnice polrn
ostream & operator<<(ostream & os, const Vector & v)
{
	if (v.mode == 'r')
		os << "(x,y) = (" << v.x << ", " << v.y << ")";
	else if (v.mode == 'p')
	{
		os << "(m,a) = (" << v.mag << ", "
		<< v.ang * Rad_to_deg << ")";
	}
	else
		os << "Neplatny rezim objektu Vector";
	return os;
}
