// bank.cpp -- pouije rozhran tdy Queue
#include <iostream>
using namespace std;
#include <cstdlib>	// pro rand() a srand()
#include <ctime>	// pro time()
#include "queue.h"
const int MIN_PER_HR = 60;

bool newcustomer(double x);		// piel nov zkaznk?

int main()
{
// nastaven
	srand(time(0));				// nhodn inicializace funkce rand()
	cout << "Pripadova studie: Bankomat Bank of Heather\n";
	cout << "Zadejte maximalni delku fronty: ";
	int qs;
	cin >> qs;
	Queue line(qs);				// ve front me bt maximln qs lid

	cout << "Zadejte pocet simulovanych hodin: ";
	int hours;					// poet simulovanch hodin
	cin >> hours;
	// jeden cyklus simulace trv jednu minutu
	long cyclelimit = MIN_PER_HR * hours; // poet cykl
	cout << "Zadejte prumerny pocet zakazniku za hodinu: ";
	double perhour;				// prmrn poet zkaznk za hodinu
	cin >> perhour;
	double min_per_cust;		// prmrn doba mezi pchodem zkaznk
	min_per_cust = MIN_PER_HR;	// za hodinu;

	Item temp;					// data novho zkaznka
	long turnaways = 0;			// poet odmtnutch zkaznk
	long customers = 0;			// poet zkaznk ve front
	long served = 0;			// poet obslouench zkaznk
	long sum_line = 0;			// celkov dlka fronty
	int wait_time = 0;			// doba ekn na bankomat
	long line_wait = 0;			// celkov doba ekn ve front

// bh simulace
	for (int cycle = 0; cycle < cyclelimit; cycle++)
	{
		if (newcustomer(min_per_cust)) // nov zkaznk
		{
			if (line.isfull())
				turnaways++;
			else
			{
				customers++;
				temp.set(cycle); // cycle = as pchodu
				line.enqueue(temp); // pid novho zkaznka do fronty
			}
		}
		if (wait_time <= 0 && !line.isempty())
		{
			line.dequeue (temp); // vyizuje dalho zkaznka
			wait_time = temp.ptime(); // po wait_time minut
			line_wait += cycle - temp.when();
			served++;
		}
		if (wait_time > 0)
			wait_time--;
		sum_line += line.queuecount();
	}

// vpis vsledk
	if (customers > 0)
	{
		cout << "    prijato zakazniku: " << customers << '\n';
		cout << " obslouzeno zakazniku: " << served << '\n';
		cout << "  odmitnuto zakazniku: " << turnaways << '\n';
		cout << "prumerna delka fronty: ";
		cout.precision(2);
		cout.setf(ios_base::fixed, ios_base::floatfield);
		cout.setf(ios_base::showpoint);
		cout << (double) sum_line / cyclelimit << '\n';
		cout << " prumerna cekaci doba: "
			 << (double) line_wait / served << " minut\n";
	}
	else
		cout << "Nejsou zadni zakaznici!\n";

	return 0;
}

// x = prmrn doba v minutch mezi dvma zkaznky
// nvratov hodnota je true, pokud se do tto doby objev nov zkaznk
bool newcustomer(double x)
{
	return (rand() * x / RAND_MAX < 1);
}
