// queue.cpp - metody tdy Customer a Queue
#include "queue.h"
#include <cstdlib>		// (nebo stdlib.h) pro rand()

// metody tdy Queue
Queue::Queue(int qs) : qsize(qs)
{
	front = rear = NULL;
	items = 0;
}

Queue::~Queue()
{
	Node * temp;
	while (front != NULL)		// dokud fronta nen przdn
	{
		temp = front;			// ulo adresu prvn poloky
		front = front->next;	// nastav ukazatel na dal poloku
		delete temp;			// zru pvodn prvn poloku
	}
}

bool Queue::isempty() const
{
	return items == 0;
}

bool Queue::isfull() const
{
	return items == qsize;
}

int Queue::queuecount() const
{
	return items;
}

// pidn prvku do fronty
bool Queue::enqueue(const Item & item)
{
	if (isfull())
		return false;
	Node * add = new Node;	// vytvo uzel
	if (add == NULL)
		return false;		// nvrat pi chyb
	add->item = item;		// nastav ukazatele uzlu
	add->next = NULL;
	items++;
	if (front == NULL)		// pokud je fronta przdn
		front = add;		// umst poloku na zatek
	else
		rear->next = add;	// jinak na konec
	rear = add;				// nastav ukazatel rear na nov uzel
	return true;
}

// Umst prvn poloku do promnn item a odebere z fronty
bool Queue::dequeue(Item & item)
{
	if (front == NULL)
		return false;
	item = front->item;		// nastav ukazatel na prvn poloku fronty
	items--;
	Node * temp = front;	// ulo adresu prvn poloky
	front = front->next;	// nastav ukazatel front na dal poloku
	delete temp;			// zru pedchoz prvn poloku
	if (items == 0)
		rear = NULL;
	return true;
}

// metoda tdy Customer

// kdy zkaznk pijde, nastav se
// as pchodu do promnn when a do promnn pedstavujc
// dobu odbaven se nastav nhodn hodnota v rozsahu 1 - 3.
void Customer::set(long when)
{
	processtime = rand() % 3 + 1;
	arrive = when;
}
