// queue.h -- rozhran tdy Queue
#ifndef _QUEUE_H_
#define _QUEUE_H_
// Tato fronta bude obsahovat poloky tdy Customer
class Customer
{
private:
	long arrive;		// as pchodu zkaznka
	int processtime;	// doba odbaven zkaznka
public:
	Customer() { arrive = processtime = 0; }
	void set(long when);
	long when() const { return arrive; }
	int ptime() const { return processtime; }
};

typedef Customer Item;

class Queue
{
// definice s platnost uvnit tdy
	// Node definice vnoen struktury existujc pouze uvnit tdy
	struct Node { Item item; struct Node * next;};
	enum {Q_SIZE = 10};
private:
	Node * front;		// ukazatel na zatek fronty
	Node * rear;		// ukazatel na konec fronty
	int items;			// aktuln poet poloek fronty
	const int qsize;	// maximln poet poloek fronty
	// preemptivn definice nutn pro zamezen veejnho koprovn
	Queue(const Queue & q) : qsize(0) { }
	Queue & operator=(const Queue & q) { return *this;}
public:
	Queue(int qs = Q_SIZE); // vytvo frontu s limitem qs
	~Queue();
	bool isempty() const;
	bool isfull() const;
	int queuecount() const;
	bool enqueue(const Item &item);	// pid poloku na konec
	bool dequeue(Item &item);		// odebere poloku ze zatku
};
#endif