// overdrft.cpp - metody tdy Overdraft
#include <iostream>
using namespace std;
#include "overdrft.h"

Overdraft::Overdraft(const char *s, long an, double bal,
		   double ml, double r) : BankAccount(s, an, bal)
{
	maxLoan = ml;
	owesBank = 0.0;
	rate = r;
}

Overdraft::Overdraft(const BankAccount & ba, double ml, double r)
		   : BankAccount(ba) // pouije implicitn koprovac konstruktor
{
	maxLoan = ml;
	owesBank = 0.0;
	rate = r;
}

// pedefinovn metody ViewAcct()
void Overdraft::ViewAcct() const
{
	// nastaven formtu ###.##
	ios_base::fmtflags initialState =
	cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);

	BankAccount::ViewAcct(); // zobraz zkladn sti
	cout << "Maximalni vyse pujcky: " << maxLoan << " Kc" << endl;
	cout << "Dluzna castka: " << owesBank << " Kc" << endl;
	cout.setf(initialState);
}

// pedefinovn funkce Withdraw()
void Overdraft::Withdraw(double amt)
{
	// nastaven formtu ###.##
	ios_base::fmtflags initialState =
		cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);

	double bal = Balance();
	if (amt <= bal)
		BankAccount::Withdraw(amt);
	else if ( amt <= bal + maxLoan - owesBank)
	{
		double advance = amt - bal;
		owesBank += advance * (1.0 + rate);
		cout << "Bankovni pujcka: " << advance << " Kc" << endl;
		cout << "Financni poplatek: " << advance * rate << " Kc" << endl;
		Deposit(advance);
		BankAccount::Withdraw(amt);
	}
	else
		cout << "Kreditni limit prekrocen. Transakce stornovana.\n";
	cout.setf(initialState);
}
