// overdyn2.cpp -- metody tdy OverdraftD s DAP
#include <iostream>
using namespace std;
#include "overdyn2.h"

OverdraftD::OverdraftD(const char * s, const char * cn,
			long an, double bal,
			double ml, double r) : BankAccountD(s, an, bal)
{
	codeName = new char[strlen(cn) + 1];
	strcpy(codeName, cn);
	maxLoan = ml;
	owesBank = 0.0;
	rate = r;
}

OverdraftD::OverdraftD(const BankAccountD & ba, const char* cn,
			double ml, double r)
			: BankAccountD(ba) // pouije explicitn koprovac konstruktor
{
	codeName = new char[strlen(cn) + 1];
	strcpy(codeName, cn);
	maxLoan = ml;
	owesBank = 0.0;
	rate = r;
}

OverdraftD::OverdraftD(const OverdraftD & od) : BankAccountD(od)
{
	codeName = new char[strlen(od.codeName) + 1];
	strcpy(codeName, od.codeName);
	maxLoan = od.maxLoan;
	owesBank = od.owesBank;
	rate = od.rate;
}

OverdraftD::~OverdraftD()
{
	delete [] codeName;
}

// pedefinovn funkce ViewAcct()
void OverdraftD::ViewAcct() const
{
	// nastav formt ###.##
	ios_base::fmtflags initialState =
	cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);

	BankAccountD::ViewAcct(); // zobraz st, patc zkladn td
	cout << "Nazev kodu: " << codeName << endl;
	cout << "Maximalni vyse pujcky: " << maxLoan << " Kc" << endl;
	cout << "Dluzna castka: " << owesBank << " Kc" << endl;
	cout.setf(initialState);
}

// pedefinovn funkce Withdraw()
void OverdraftD::Withdraw(double amt)
{
	// nastaven formtu ###.##
	ios_base::fmtflags initialState =
		cout.setf(ios_base::fixed, ios_base::floatfield);
	cout.setf(ios_base::showpoint);
	cout.precision(2);
	double bal = Balance();
	if (amt <= bal)
		BankAccountD::Withdraw(amt);
	else if ( amt <= bal + maxLoan - owesBank)
	{
		double advance = amt - bal;
		owesBank += advance * (1.0 + rate);
		cout << "Bankovni pujcka: " << advance << " Kc" << endl;
		cout << "Financni poplatek: " << advance * rate << " Kc" << endl;
		Deposit(advance);
		BankAccountD::Withdraw(amt);
	}
	else
		cout << "Kreditni limit prekrocen. Transakce stornovana.\n";
	cout.setf(initialState);
}

OverdraftD & OverdraftD::operator=(const OverdraftD & od)
{
	if (this == &od)
		return *this;
	BankAccountD::operator=(od); // piazen sti, patc
	// zkladn td
	delete [] codeName;
	codeName = new char[strlen(od.codeName) + 1];
	strcpy(codeName, od.codeName);
	maxLoan = od.maxLoan;
	owesBank = od.owesBank;
	rate = od.rate;
	return *this;
}
