// arraydb.cpp -- metody tdy ArrayDb
#include <iostream>
using namespace std;
#include <cstdlib> // prototyp funkce exit()
#include "arraydb.h"

// bezparamerick konstruktor
ArrayDb::ArrayDb()
{
	arr = NULL;
	size = 0;
}

// vytvoen pole s n prvky s nastavenmi na hodnotou val
ArrayDb::ArrayDb(unsigned int n, double val)
{
	arr = new double[n];
	size = n;
	for (int i = 0; i < size; i++)
	arr[i] = val;
}

// inicializace objektu pomoc normlnho pole
ArrayDb::ArrayDb(const double *pn, unsigned int n)
{
	arr = new double[n];
	size = n;
	for (int i = 0; i < size; i++)
	arr[i] = pn[i];
}

// inicializace objektu tdy ArrayDb jinm objektem stejn tdy
ArrayDb::ArrayDb(const ArrayDb & a)
{
	size = a.size;
	arr = new double[size];
	for (int i = 0; i < size; i++)
	arr[i] = a.arr[i];
}

ArrayDb::~ArrayDb()
{
	delete [] arr;
}

double ArrayDb::Average() const
{
	double sum = 0;
	int i;
	int lim = ArSize();
	for (i = 0; i < lim; i++)
		sum += arr[i];
	if (i > 0)
		return sum / i;
	else
	{
		cerr << "Zadne zaznamy v poli vysledku\n";
		return 0;
	}
}

// umon uivateli pistupovat k prvkm pomoc indexu
// (piazen povoleno)
double & ArrayDb::operator[](int i)
{
	// kontrola ped pokraovnm
	if (i < 0 || i >= size)
	{
	cerr << "Prekroceny meze pole: "
	<< i << " je neplatny index\n";
	exit(1);
	}
	return arr[i];
}

// umon uivateli pistupovat k prvkm pomoc indexu
// (piazen zakzno)
const double & ArrayDb::operator[](int i) const
{
	// kontrola indexu ped pokraovnm
	if (i < 0 || i >= size)
	{
		cerr << "Prekroceny meze pole: "
			 << i << " je neplatny index\n";
		exit(1);
	}
	return arr[i];
}

// definice opertoru piazen
ArrayDb & ArrayDb::operator=(const ArrayDb & a)
{
	if (this == &a)		// je-li objekt piazen sm sob,
		return *this;	// dn zmna se neprovede
	delete [] arr;
	size = a.size;
	arr = new double[size];
	for (int i = 0; i < size; i++)
		arr[i] = a.arr[i];
	return *this;
}

// sporn rychl vstup, 5 hodnot na dek
ostream & operator<<(ostream & os, const ArrayDb & a)
{
	int i;
	for (i = 0; i < a.size; i++)
	{
		os << a.arr[i] << " ";
		if (i % 5 == 4)
			os << "\n";
	}
	if (i % 5 != 0)
		os << "\n";
	return os;
}
