// worker.h -- tdy pracujcch
#include "strng2.h"

class Worker // abstraktn zkladn tda
{
private:
	String fullname;
	long id;
public:
	Worker() : fullname("no one"), id(0L) {}
	Worker(const String & s, long n)
		: fullname(s), id(n) {}
	virtual ~Worker() = 0; // ist virtuln destruktor
	virtual void Set();
	virtual void Show() const;
};

class Waiter : public Worker
{
private:
	int panache;
public:
	Waiter() : Worker(), panache(0) {}
	Waiter(const String & s, long n, int p = 0)
		: Worker(s, n), panache(p) {}
	Waiter(const Worker & wk, int p = 0)
		: Worker(wk), panache(p) {}
	void Set();
	void Show() const;
};

class Singer : public Worker
{
protected:
	enum {jiny, alt, kontralt, sopran,
				bas, bariton, tenor};
	enum {Vtypes = 7};
private:
	static char *pv[Vtypes]; // etzce pro typy hlasu
	int voice;
public:
	Singer() : Worker(), voice(jiny) {}
	Singer(const String & s, long n, int v = jiny)
		: Worker(s, n), voice(v) {}
	Singer(const Worker & wk, int v = jiny)
		: Worker(wk), voice(v) {}
	void Set();
	void Show() const;
};

class Greeter : public Worker
{
private:
	int cheer;
public:
Greeter() : Worker(), cheer(0) {}
	Greeter(const String & s, long n, int c = 0)
		: Worker(s, n), cheer(c) {}
	Greeter(const Worker & wk, int c = 0)
		: Worker(wk), cheer(c) {}
	void Set();
	void Show() const;
};
