// workermi.h -- tdy pro vcensobnou ddinost
#include "strng2.h"

class Worker // abstraktn zkladn tda
{
private:
	String fullname;
	long id;
protected:
	virtual void Data() const;
	virtual void Get();
public:
	Worker() : fullname("no one"), id(0L) {}
	Worker(const String & s, long n)
			: fullname(s), id(n) {}
	virtual ~Worker() = 0; // ist virtuln funkce
	virtual void Set() = 0;
	virtual void Show() const = 0;
};

class Waiter : virtual public Worker
{
private:
	int panache;
protected:
	void Data() const;
	void Get();
public:
	Waiter() : Worker(), panache(0) {}
	Waiter(const String & s, long n, int p = 0)
			: Worker(s, n), panache(p) {}
	Waiter(const Worker & wk, int p = 0)
			: Worker(wk), panache(p) {}
	void Set();
	void Show() const;
};

class Singer : virtual public Worker
{
protected:
	enum {jiny, alt, kontralt, sopran,
	bas, bariton, tenor};
	enum {Vtypes = 7};
	void Data() const;
	void Get();
private:
	static char *pv[Vtypes]; // etzce pro typy hlasu
	int voice;
	public:
	Singer() : Worker(), voice(jiny) {}
	Singer(const String & s, long n, int v = jiny)
			: Worker(s, n), voice(v) {}
	Singer(const Worker & wk, int v = jiny)
			: Worker(wk), voice(v) {}
	void Set();
	void Show() const;
};

// vcensobn ddinost
class SingingWaiter : public Singer, public Waiter
{
protected:
	void Data() const;
	void Get();
public:
	SingingWaiter() {}
	SingingWaiter(const String & s, long n, int p = 0,
							int v = Singer::jiny)
			: Worker(s,n), Waiter(s, n, p), Singer(s, n, v) {}
	SingingWaiter(const Worker & wk, int p = 0, int v = Singer::jiny)
			: Worker(wk), Waiter(wk,p), Singer(wk,v) {}
	SingingWaiter(const Waiter & wt, int v = jiny)
			: Worker(wt),Waiter(wt), Singer(wt,v) {}
	SingingWaiter(const Singer & wt, int p = 0)
			: Worker(wt),Waiter(wt,p), Singer(wt) {}
	void Set();
	void Show() const;
};
