// queuetp.h -- ablona fronty s vnoenou tdou
template <class Item>
class QueueTP
{
private:
	enum {Q_SIZE = 10};
	// Node je definice vnoen tdy
	class Node
	{
	public:
		Item item;
		Node * next;
		Node(const Item & i):item(i), next(0){ }
	};
	Node * front;		// ukazatel na zatek fronty
	Node * rear;		// ukazatel na konec fronty
	int items;			// aktuln poet poloek fronty
	const int qsize;	// maximln poet poloek fronty
	QueueTP(const QueueTP & q) : qsize(0) {}
	QueueTP & operator=(const QueueTP & q) { return *this; }
public:
	QueueTP(int qs = Q_SIZE);
	~QueueTP();
	bool isempty() const
	{
		return items == 0;
	}
	bool isfull() const
	{
		return items == qsize;
	}
	int queuecount() const
	{
		return items;
	}
	bool enqueue(const Item &item); // pid poloku na konec fronty
	bool dequeue(Item &item); // odebere poloku z fronty
};

// metody ablony QueueTP
template <class Item>
QueueTP<Item>::QueueTP(int qs) : qsize(qs)
{
	front = rear = 0;
	items = 0;
}

template <class Item>
QueueTP<Item>::~QueueTP()
{
	Node * temp;
	while (front != 0) // dokud fronta nen przdn
	{
		temp = front; // ulo adresu prvn poloky
		front = front->next;// nastav ukazatel na nsledujc poloku
		delete temp; // zru pvodn prvn poloku
	}
}

// Pidn poloky na konec fronty
template <class Item>
bool QueueTP<Item>::enqueue(const Item & item)
{
	if (isfull())
		return false;
	Node * add = new Node(item);	// vytvo uzel
	if (add == NULL)
		return false;				// konec v ppad nedostatku pamti
	items++;
	if (front == 0)					// jestlie je fronta przdn,
		front = add;				// pid poloku na zatek fronty
	else
		rear->next = add;			// jinak na konec fronty
	rear = add;						// ukazatel na konec fronty ukazuje na nov uzel
	return true;
}

// Ulo prvn poloku do promnn item a odstran ji z fronty
template <class Item>
bool QueueTP<Item>::dequeue(Item & item)
{
	if (front == 0)
		return false;
	item = front->item;				// nastav item na prvn poloku fronty
	items--;
	Node * temp = front;			// ulo adresu prvn poloky
	front = front->next;			// nastav zatek na nsledujc poloku
	delete temp;					// zru pvodn prvn poloku
	if (items == 0)
		rear = 0;
	return true;
}
