// arraydbe.cpp -- metody tdy ArrayDbE
#include <iostream>
using namespace std;
#include "arraydbe.h"

// bezparametrick konstruktor
ArrayDbE::ArrayDbE()
{
	arr = NULL;
	size = 0;
}

// vytvo pole o n prvcch, kad je nastaven na hodnotou val
ArrayDbE::ArrayDbE(unsigned int n, double val)
{
	arr = new double[n];
	size = n;
	for (int i = 0; i < size; i++)
		arr[i] = val;
}

// inicializuje objekty tdy ArrayDbE pomoc klasickho pole
ArrayDbE::ArrayDbE(const double *pn, unsigned int n)
{
	arr = new double[n];
	size = n;
	for (int i = 0; i < size; i++)
		arr[i] = pn[i];
}

// inicializuje objekt tdy ArrayDbE pomoc jinho objektu tto tdy
ArrayDbE::ArrayDbE(const ArrayDbE & a)
{
	size = a.size;
	arr = new double[size];
	for (int i = 0; i < size; i++)
		arr[i] = a.arr[i];
}

ArrayDbE::~ArrayDbE()
{
	delete [] arr;
}

double ArrayDbE::Average() const
{
	double sum = 0;
	int i;
	int lim = ArSize();
	for (i = 0; i < lim; i++)
		sum += arr[i];
	if (i > 0)
		return sum / i;
	else
	{
		cerr << "V poli zaznamu nejsou zadne udaje\n";
		return 0;
	}
}

// vrt velikost pole
unsigned int ArrayDbE::ArSize() const
{
	return size;
}

// umon uivateli pistupovat k prvkm pomoc indexu (piazen povoleno)
double & ArrayDbE::operator[](int i) throw(BadIndex &)
{
	// kontrola indexu
	if (i < 0 || i >= size)
		throw BadIndex(i);
	return arr[i];
}

// umon uivateli pistupovat k prvkm pomoc indexu (piazen zakzno)
const double & ArrayDbE::operator[](int i)const throw(BadIndex &)
{
	// kontrola indexu
	if (i < 0 || i >= size)
		throw BadIndex(i);
	return arr[i];
}

// definuje piazen tdy
ArrayDbE & ArrayDbE::operator=(const ArrayDbE & a)
{
	if (this == &a) // je-li objekt piazen sm sob,
		return *this; // nic nedlej
	delete arr;
	size = a.size;
	arr = new double[size];
	for (int i = 0; i < size; i++)
		arr[i] = a.arr[i];
	return *this;
}

// spornj rychl vstup, 5 hodnot na dek
ostream & operator<<(ostream & os, const ArrayDbE & a)
{
	int i;
	for (i = 0; i < a.size; i++)
	{
		os << a.arr[i] << " ";
		if (i % 5 == 4)
			os << "\n";
	}
	if (i % 5 != 0)
		os << "\n";
	return os;
}
