//usealgo.cpp
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <cctype>
using namespace std;

string & ToLower(string & st);

int main()
{
	vector<string> words;
	cout << "Zadejte slova (\"konec\" pro ukonceni):\n";
	string input;
	while (cin >> input && input != "konec")
		words.push_back(input);

	cout << "Zadali jste nasledujici slova:\n";
	ostream_iterator<string,char> out(cout, " ");
	copy(words.begin(), words.end(), out);
	cout << endl;

	// vloen slov do kontejneru typu set, konverze na mal psmena
	set<string> wordset;
	transform(words.begin(), words.end(),
		insert_iterator<set<string> > (wordset, wordset.begin()),
		ToLower);
	cout << "\nSeznam slov podle abecedy:\n";
	copy(wordset.begin(), wordset.end(), out);
	cout << endl;

	// vloen slov a poet vskyt do kontejneru typu map
	map<string, int> wordmap;
	set<string>::iterator si;
	for (si = wordset.begin(); si != wordset.end(); si++)
		wordmap[*si] = count(words.begin(), words.end(), *si);

	// zobrazen obsahu kontejneru typu map
	cout << "\nPocet vyskytu:\n";
	for (si = wordset.begin(); si != wordset.end(); si++)
		cout << *si << ": " << wordmap[*si] << endl;
	return 0;
}

string & ToLower(string & st)
{
	transform(st.begin(), st.end(), st.begin(), tolower);
	return st;
}
